# Method: namespaces.services.replaceService

- [HTTP request](https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services/replaceService#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services/replaceService#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services/replaceService#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services/replaceService#body.request_body)
- [Response body](https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services/replaceService#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services/replaceService#body.aspect)

Replaces a service.

Only the spec and metadata labels and annotations are modifiable. After the Update request, Cloud Run will work to make the 'status' match the requested 'spec'.

May provide metadata.resourceVersion to enforce update from last read for optimistic concurrency control.

### HTTP request

`PUT https://run.googleapis.com/apis/serving.knative.dev/v1/{name}`

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The fully qualified name of the service to replace. It can be any of the following forms: - `namespaces/{project_id_or_number}/services/{serviceName}` (only when the `endpoint` is regional) - `projects/{project_id_or_number}/locations/{region}/services/{serviceName}` - `projects/{project_id_or_number}/regions/{region}/services/{serviceName}` It takes the form `namespaces/{namespace}/services/{service}`. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `name`: - `run.services.update` |

### Query parameters

| Parameters ||
|---|---|
| `dryRun` | `string` Indicates that the server should validate the request and populate default values without persisting the request. Supported values: `all` |

### Request body

The request body contains an instance of `https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services#Service`.

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/run/docs/reference/rest/v1/namespaces.services#Service`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).